COMMENT %
The song's text must BE in UPPER CASE and NO shorten (just like I'VE)
Simulate a Karaoke with 2 scrolling, sorry no backgrd music.
Control by:
Song1: F1/f2/f3 (speed+, speed-, pause) 
Song2: F5/f6/f7 (speed+, speed-, pause) 
Mission: 1) load a fine font  2)load the 2 songs  3) share the time between the 2 scroling (use temporate variables/buffers and delay procedure for realize it) 4) use keyboard intercept (install a new interrupt handler with code in cs segment) to get the input from user.
Enjoy Tuan Nguyen Denmark 2002
%
.MODEL medium
.STACK 
.DATA 
BUFFER DB 15000 DUP (?) ;THE FONT FILE FROM 32-90 (SPACE TO Z) FILLS NOTHING. DO NOT USE LOWCASE, COS THE TRANSFORM FROM TRUE TYPE TO BITMAP FONT MADE THE CHAR VERY HARD TO READ.
;MUST BE ONLY 9 CHAR BETWEEN ""
SONG1   DB "SONG1.TXT",0,8
SONG2   DB "SONG2.TXT",0,8
di_tmp dw ?
di_song1 dw 5760   ;position on screen 30*320
di_song2 dw 38400
buffer_song1 db 3000 dup (?)  ;reserved space for song
buffer_song2 db 3000 dup (?)
song1_len dw ?   ;length
song2_len dw ?
flagsong1 db 0
flagsong2 db 0
si_song1 dw 0   ;keep the order of the char moving from buffer_song1 to temp
si_song2 dw 0
ERRMSGOPEN DB "File missing. `"
FILENAME DB "1.FNT",0,8,"'$" ;8 IS A DELETE CHARACTER
FILELENGTH DW 0
HEIGHT DW ?
NUMBER DB 0
COLOR DB ?
;COL DB 122 ;STARTING COLOUR
COL DB 11
GUIDE DB 'Sg1: F1/F2/F3 (V+ V- P) Sg2: F5/F6/F7'
Author db 'Tuan Nguyen Copenhagen, The assembler challenge'
TEMP DB 22 DUP(' ') ;22 CHARS CAN BE ON A SAME TIME
TEMP_SONG1 DB 22 DUP(' ') ;22 CHARS CAN BE ON A SAME TIME
TEMP_SONG2 DB 22 DUP(' ') ;22 CHARS CAN BE ON A SAME TIME
PIXEL_SECOND_COLUMN DW 0
DELAY_TIME DW 400  ;default/init value


.CODE 
START:
    
    mov ax, @data
    mov ds, ax ;load ds segment
    CALL    InstallNewInt9          ; Install keyboard intercept
    call readfile ;read "1.fnt"
    mov ah, 00h ; set video mode
    mov al, 13h ; mode 13h
    int 10h ; we are now in 320x200x256

    mov ax,ds  ;write string in graphics
    mov es,ax
    lea bp, guide
    mov ah,013h  ;service 
    mov al,1  ;subservice 
    mov bl,1  ;color 
    mov cx,37 ;37 chars
    mov dh,22 ;row
    mov dl,0;column
    int 10h

    mov ax,0a000h ;ax = segment to screen in mode 13h
    mov es,ax ;move seg addr to es

;---------------------------------------------------------------------
SONGREAD MACRO PARAM, param2, param3  ;read song file (song,buffer,length)
    mov ax,3d00h ;open file (ah=3dh)
    mov dx, PARAM
    int 21h
    ;jc openerror
    mov bx,ax ;move the file handle into bx
    mov dx,offset param2; load to ds:offset buffer
    mov ah,3fh
    mov cx,15000 ;reserved buffer
    int 21h ;ax bliver antal read bytes
    mov param3,ax
    mov ah,3eh
    int 21h ;close file
ENDM songread

;read songs in buffer. The names are hardcoded (sorry)
    xor dx,dx
    add dx,15000   ;postion in segment ds just after the reserved buffer
    songread dx,buffer_song1,song1_len   ;read the song in buffer, 3 IN
    xor dx,dx
    add dx,15011   ;postion in segment ds just after the reserved buffer
    songread dx,buffer_song2,song2_len   ;read the song in buffer, 3 IN

;SHARING TIME BETWEEN 2 SCROLLS
SONG1_TIMESLIDE:
    mov dx,di_song1
    mov di_tmp,dx  ;the position for song1 on screen
    cmp flagsong1,88
    je stay_here
    cmp cs:f3,1  ;pause ?
    je pause
    jmp nopause
PAUSE:
    mov flagsong1,88   ;to indicate that pause is ON
    mov cs:f3,0  ;reset variable f3
    stay_here:   ;go inside the loop
    cmp cs:f3,1   ;did the user press F3 again?
    je release   ;yes, unpause
    call delay  ;simulate some delay cos now only 1 scrolling
    jmp song2_timeslide
RELEASE:
    mov cs:f3,0  ;reset before release
    mov flagsong1,0   ;to indicate that pause is OFF
    jmp nopause
NOPAUSE:
    call song1_proc

SONG2_TIMESLIDE:
    mov dx,di_song2
    mov di_tmp,dx  ;the position for song2 on screen
    cmp flagsong2,88
    je stay_here2
    cmp cs:f7,1  ;pause ?
    je pause2
    jmp nopause2
PAUSE2:
    mov flagsong2,88   ;to indicate that pause is ON
    mov cs:f7,0  ;reset variable f7
STAY_HERE2:   ;go inside the loop
    cmp cs:f7,1   ;did the user press f7 again?
    je release2   ;yes, unpause
    call delay;simulate some delay cos now only 1 scrolling
    jmp song3_timeslide
RELEASE2:
    mov cs:f7,0  ;reset before release
    mov flagsong2,0   ;to indicate that pause is OFF
    jmp nopause2
NOPAUSE2:
    call song2_proc

SONG3_TIMESLIDE:
    cmp     cs:exittoggle,1  ;want to escape?
    jz      exit
    jmp song1_timeslide

EXIT:
    call removenewint9
    mov ax,3
    int 10h
    mov ax,04c00h
    int 21h
    
OPENERROR:
    call removenewint9
    mov ah,9
    mov dx,offset errmsgopen
    int 21h
    mov ax,4c00h
    int 21h

;data for key intercept
OldInt9Address          DD      0   ; Buffer for original interrupt address
StoreAX                 DW      0
KeyPress                DB      0
ExitToggle              DB      0
F1 db 0
F2 db 0
F3 db 0
F5 db 0
F6 db 0
F7 db 0

;---------------------------------------------------------------------
OPENERROR2 proc
    call removenewint9
    mov ah,9
    mov dx,offset errmsgopen
    int 21h
    mov ax,4c00h
    int 21h
ret
openerror2 endp
;---------------------------------------------------------------------
READFILE PROC
    mov ax,3d00h ;open file (ah=3dh)
    mov dx,offset filename
    int 21h;bios isr
    jc openerror
    mov bx,ax ;move the file handle into bx
    mov dx,offset buffer; load to ds:offset buffer
    mov ah,3fh
    mov cx,15000 ;reserved buffer
    int 21h ;ax bliver antal read bytes
    mov filelength,ax
    mov ah,3eh
    int 21h ;close file
    ret
READFILE ENDP
;---------------------------------------------------------------------
DRAW PROC
    mov ax,word ptr buffer[88] ;at position 58h (88d) you have max pixel height
    mov height,ax
    mov di,di_tmp   ;where to place the text on screen
    
    mov bx,0
@1: 
    mov al,temp[bx] ; get ascii code
    push bx
    xor ah,ah
    sub ax,32 ;sub it from 32. chars59 begins with space (ascii 32)
    shl ax,2 ;4 bytes for eache char infos
    mov si,ax ;for indexing
    mov cx,word ptr buffer[078h+si] ;the position of the char (see fnt specs)
    mov al,byte ptr buffer[076h+si] ;the first width posi of space in the font file
    
    cmp al,8 ;if only 1 byte width call 1bytewidth
    ja twobytewid
    call onebytewidth ;get char from buffer and show it
    jmp nextchar
TWOBYTEWID:
    call twobytewidth ;get char from buffer and show it
    
NEXTCHAR:
    pop bx
    inc bx
    mov di,di_tmp
    mov ax,14 ;made some spaces between chars
    mul bx ;spaces after a number of char
    add di,ax ;get a new di
    cmp bx,22 ;the number of chars
    jne @1
    ret
DRAW ENDP
    
;---------------------------------------------------------------------

ONEBYTEWIDTH PROC
    mov si,cx ;pointer to the char bitmap at the buffer
    mov dx,height ;"height" rows in a character
    mov bl,col
    mov color,bl
    
    charloop: ;read one of the x rows for a char
    
    lodsb ;one row contains 8 pixels f.e char b 11111100 (first row). load from ds:si to al
    mov bl,al ;use late on to indicate when the pixels is "blank"
    mov cx,8 ;for 8 pixels
    
    rowloop: ;for 8 pixels in a row
    mov al,color ;this value will be store in buffer
    shl bl,1 ;1 pixel stores as 1 byte! store from left to right, f.e 1 is the first value for the char b above. it shifts the read value to left, if the leftmost value is a 1 then the carry flag will rise!! using for the next move
    jc carryset ;use this to indicate whether there is a 0 or a 1
    xor al,al ; no carry means a 0
CARRYSET:
    stosb;just store al in es:di
    
    loop rowloop
;NEW DI POS ON THE SCREEN
; SUB COLOR,3 ;CHANGE COLOR AVERY ROW
    add di,(320-8) ;add a newline minus 16 pixels back
    dec dx ;height
    jnz charloop
    ret
ONEBYTEWIDTH ENDP
;---------------------------------------------------------------------
TWOBYTEWIDTH PROC
    mov si,cx ;pointer to the char bitmap at the buffer
    cmp al,16
    ja use_only_2_column
    sub al,8 ;find the number of pixels needed for the second column
;for proportional fonts U need to "expand" the pixels DYNAMICALLY. Trick: use the predefined 
    mov byte ptr pixel_second_column,al ;the width infos
    jmp @2
USE_ONLY_2_COLUMN:
    mov byte ptr pixel_second_column,8 ;the width infos
@2:
    mov dx,height
    mov bl,col
    mov color,bl
    
CHARLOOP2: ;read one of the x rows for a char
    lodsb ;one row contains 8 pixels f.e char b 11111100 (first row). load from ds:si to al
    mov bl,al ;use late on to indicate when the pixels is "blank"
    mov cx,8 ;for 8 pixels
    rowloop2: ;for 8 pixels in a row
    mov al,color ;this value will be store in buffer
    shl bl,1
    jc carryset2 ;use this to indicate whether there is a 0 or a 1
    xor al,al ; no carry means a 0
CARRYSET2:
    stosb;just store al in es:di
    loop rowloop2
    
;TAKE THE SECOND COLUMN
    add si,height ;take the right side (the second column) of the bitmap font
    sub si,1 ;some justement
    
    lodsb ;one row contains 8 pixels f.e char b 11111100 (first row). load from ds:si to al
    mov bl,al ;use late on to indicate whether the pixels is "blank"
    mov cx,pixel_second_column ;the number of pixels
    rowloop3: ;for 8 pixels in a row
    mov al,color ;this value will be store in buffer
    shl bl,1
    jc carryset3 ;use this to indicate whether there is a 0 or a 1
    xor al,al ; no carry means a 0
CARRYSET3:
    stosb;just store al in es:di
    loop rowloop3
    
;GET BACK TO THE FIRST COLUMN
    sub si,height ;take the left side (1.column)
    
;NEW DI POS ON THE SCREEN
; SUB COLOR,3 ;CHANGE COLOR AVERY ROW
    add di,(320-8);add a newline minus 8 pixels back
    sub di,pixel_second_column ;minus the pixels on the second column
    dec dx ;height
    jnz charloop2
    
    ret
TWOBYTEWIDTH ENDP
;---------------------------------------------------------------------
WTSYNC PROC ; wtsync waits for the vertical retrace That is when the electron beam jumps back from the bottom right corner of the screen to the upper left corner of the screen This gives us a chance to draw things on the screen, changing 
;the palette and stuff like that while the electron beam aint drawing 
    mov dx,3dah
WAITVR1:
    in al,dx
    test al,8
    jne waitvr1
WAITVR2:
    in al,dx
    test al,8
    je waitvr2
    ret
WTSYNC ENDP

;-----------------------------------------------------------------------
;Interrupt 015h: Calling AH = 04fh KEY intercept
;the keyboard generetes an INT 9h every time the key is pushed or released
;                 Routine will look at AL, where the caller (Int 9) will have
;                 placed the scan code.
; Installs new int 9 handler

InstallNewInt9          PROC    NEAR

MOV     AH,035h                         ; Ask for interrupt address function
MOV     AL,015h                         ; Interrupt we're asking for
INT     021h                            ; Ask for it
MOV     Word Ptr OldInt9Address,BX      ; Save current segment of interrupt
MOV     Word Ptr OldInt9Address[2],ES   ; Save current offset of interrupt

push ds    ;prepare for addr for new interrupt handler
mov ax,cs   ;ds:dx  = addr of inter. handler
mov ds,ax

MOV     AH,025h                         ; Insert new address for interrupt function
MOV     AL,015h                         ; Interupt we want to change
MOV     DX,Offset NewInt9Handler        ; New address to point to (this TSR)
INT     021h                            ; Set it

pop ds ;restore the "original" DS

RET
InstallNewInt9          ENDP
;-----------------------------------------------------------------------

; Removes new int 9 handler
RemoveNewInt9           PROC    NEAR

push ds  ;prepare for remove the "installed" interrupt

MOV     DX,Word Ptr OldInt9Address      ; New address to point to 
MOV     AX,Word Ptr OldInt9Address[2]
MOV     DS,AX
MOV     AH,025h                         ; Insert new address for interrupt function
MOV     AL,015h                         ; Interupt we want to change
INT     021h                            ; Set it
pop DS
RET
RemoveNewInt9           ENDP

; Actual routine to be called when int 9 is tripped
;-----------------------------------------------------------------------
NewInt9Handler          PROC    FAR
Assume  CS:@code

CMP     AH,04fh   ;int 9h calls this one
JNZ     NotIntercept

TEST    AL,080h   ;10000000b (key release= key OR 080h) True (=1) if no keypress
JNZ     NoKeyPress
MOV     KeyPress,1

NoKeyPress:
; Check ESC and F1-F11

CMP     AL,1                 ; Has ESC been pressed?
JNZ     keyF1
MOV     ExitToggle,1

KEYF1:
CMP     AL,03bh                 ; Has F1 been pressed?
JNZ     KEYF2
MOV     F1,1

KEYF2:
CMP     AL,03ch                 ; Has F2 been pressed?
JNZ     KEYF3
MOV     F2,1

KEYF3:
CMP     AL,03dh                 ; Has F3 been pressed?
JNZ     KEYF5
MOV     F3,1

KEYF5:
CMP     AL,03Fh                 ; Has F5 been pressed?
JNZ     KEYF6
MOV     F5,1

KEYF6:
CMP     AL,040h
JNZ     KEYF7
MOV     F6,1

KEYF7:
CMP     AL,041h
JNZ     NotIntercept
MOV     F7,1

; Clear keyboard buffer (BIOS routine is still called, and it annoyingly beeps when it's buffer is full)

NotIntercept:  ;set tail=head to clear the buffer
MOV     StoreAX,AX
MOV     AX,40:[01ch]   ;low memory usage =0:41ch keyboard buffer tail
MOV     40:[01ah],AX   ;=:41ah   buffer head
MOV     AX,StoreAX
CLC

IRET
NewInt9Handler          ENDP

;---------------------------------------------------------------------
DELAY PROC
    push cx dx
    mov cx, 0
    mov dx,delay_time
;    mov dx,02ffh ;change this one to 0fffh if you have a 2GHz cpu
;TAKE 1,2 SEK FOR YOU TO EXIT/ESC !!!
BIGLOOP:
DELAYLOOP:
    dec cx
    jnz delayloop
    dec dx
    jnz bigloop
    pop dx cx
    ret
DELAY ENDP
;---------------------------------------------------------------------
SONG1_PROC PROC    ;READ SONG1
    mov si,si_song1   ;restore the previous position at the song
    mov al,buffer_song1[si]  ;get one char from text and put it at "the end" of temp
    mov bx,1 ;castle value in buffer temp, 0 is the leftmost:1->0, 2->1, 3->2 and 4->3 ;(simulere the number, movement like a calculator)
CASTLE_LOOP:  ;take a char from buffer_song1 and move temp[] one position to the left
    mov dl,temp_song1[bx]
    mov temp_song1[bx-1],dl
    inc bx
    cmp bx,22
    jne castle_loop
    mov temp_song1[21],al ;the last position in the buffer
;copy to temp
    xor bx,bx
COPY_SONG1:
    mov cl,temp_song1[bx]
    mov temp[bx],cl
    inc bx
    cmp bx,22
    jne copy_song1
    inc si
    mov si_song1,si  ;store si for next time slice
;CLS THE SCREEN
    mov di,5760 ;at the top of the screen 18*320
    mov cx,8960  ;28*320  (max height is about 28pixels ASSUMED)
    mov al,0
    rep stosb
    cmp si,song1_len   ;reset to the begin of the song
    je reset
    jmp @3
RESET:
    mov si_song1,0
@3:
     call draw  ;draw temp
     call delay
     cmp cs:keypress,1
     jne return 
     CMP     cs:f1,1     ;did F1 pressed
     Je f1_v_plus
     CMP     cs:f2,1
     Je f2_v_descent
     ret
F1_V_PLUS: 
    cmp delay_time,101  ;trick use 101, you get loop problem with 100
    jb nomore
    jmp @5
NOMORE:  ;AT 100 DO NOT ALLOWED TO GO FURTHER DOWN
    mov cs:f1,0
    ret
@5:     
    sub delay_time,100
    mov cs:f1,0
    ret
F2_V_DESCENT: 
    cmp delay_time,65000  ; a real 999Ghz machine!!!
    ja nomore2
    jmp @6
NOMORE2:
    mov cs:f2,0
    ret
@6:     
    add delay_time,100
    mov cs:f2,0
RETURN:
    ret
SONG1_PROC ENDP
;-----------------------------------------------------------------------
SONG2_PROC PROC    ;READ SONG2
    mov si,si_song2   ;restore the previous position at the song
    mov al,buffer_song2[si]  ;get one char from text and put it at "the end" of temp
    mov bx,1 ;castle value in buffer temp, 0 is the leftmost:1->0, 2->1, 3->2 and 4->3 ;(simulere the number, movement like a calculator)
CASTLE_LOOP2:  
    mov dl,temp_song2[bx]
    mov temp_song2[bx-1],dl
    inc bx
    cmp bx,22
    jne castle_loop2
    mov temp_song2[21],al ;the last position in the buffer
;copy to temp
    xor bx,bx
COPY_SONG2:
    mov cl,temp_song2[bx]
    mov temp[bx],cl
    inc bx
    cmp bx,22
    jne copy_song2
    inc si
    mov si_song2,si  ;store si for next time slice
;CLS THE SCREEN
    mov di,38400
    mov cx,8960  ;28*320  (max height is about 28pixels ASSUMED)
    mov al,0
    rep stosb
    cmp si,song2_len   ;reset to the begin of the song
    je reset2
    jmp @9
RESET2:
    mov si_song2,0
@9:
     call draw  ;draw buffer temp
     call delay
     cmp cs:keypress,1
     jne return2 
     CMP     cs:f5,1     ;did F5 pressed
     Je f5_v_plus
     CMP     cs:f6,1
     Je f6_v_descent
     ret
F5_V_PLUS: 
    cmp delay_time,101  ;trick use 101, you get loop problem with 100
    jb nomore3
    jmp @7
NOMORE3:  ;AT 100 DO NOT ALLOWED TO GO FURTHER DOWN
    mov cs:f5,0
    ret
@7:     
    sub delay_time,100
    mov cs:f5,0
    ret
F6_V_DESCENT: 
    cmp delay_time,65000  ; a real 999Ghz machine!!!
    ja nomore4
    jmp @8
NOMORE4:
    mov cs:f6,0
    ret
@8:     
    add delay_time,100
    mov cs:f6,0
RETURN2:
    ret
SONG2_PROC ENDP
;-----------------------------------------------------------------------
END START
