COMMENT %
Extract the bitmap infos from many diff free true type fonts and use it in your prg.
Use Softy to convert TrueType to FNT!!! A good software

Only test with the font format (.FNT), using in SoftyV1.07. This format do not match 100 procent the original format from MicroSoft. It did not use some fields, but I think it is legal ???

It works both for fixed and proportional font. 

2 columns means: the pixels store for "one column"  height rows, when the first column complete it continues on the second column ( height row too). pls read the fileformat specs for .fnt. BTW I use only MAX 2 columns in my asm.

Mission: read the font in buffer, extract the bitmap information for each char coresponding to the "text", and then plot it on the screen. 
%
.MODEL SMALL
.STACK 20H
.DATA
BUFFER DB 5000 DUP (?) ;THE FONT FILE FROM 32-90 (SPACE TO Z) FILLS NOTHING. DO NOT USE LOWCASE, COS THE TRANSFORM FROM TRUE TYPE TO BITMAP FONT MADE THE CHAR VERY HARD TO READ.
ERRMSGOPEN DB "ERROR OPENING `"
FILENAME DB "1.FNT",0,8,"'$" ;8 IS A DELETE CHARACTER
FILELENGTH DW 0
HEIGHT DW ?
NUMBER DB 0
COLOR DB ?
;COL DB 122 ;STARTING COLOUR
COL DB 11
TEXT DB 'FONT123. TUAN NGUYEN Z'
PIXEL_SECOND_COLUMN DW 0

.CODE
START:
    
    mov ax, @data
    mov ds, ax ;load ds segment
    call readfile ;read "1.fnt"
    
    mov ah, 00h ; set video mode
    mov al, 13h ; mode 13h
    int 10h ; we are now in 320x200x256
    call draw
    
    mov ah,7
    int 21h
    mov ax,3
    int 10h
    mov ax,04c00h
    int 21h
    
OPENERROR:
    mov ah,9
    mov dx,offset errmsgopen
    int 21h
    mov ax,4c00h
    int 21h
;---------------------------------------------------------------------
READFILE PROC
    mov ax,3d00h ;open file (ah=3dh)
    mov dx,offset filename
    int 21h;bios isr
    jc openerror
    mov bx,ax ;move the file handle into bx
    mov dx,offset buffer; load to ds:offset buffer
    mov ah,3fh
    mov cx,5000 ;reserved buffer
    int 21h ;ax bliver antal read bytes
    mov filelength,ax
    mov ah,3eh
    int 21h ;close file
    ret
READFILE ENDP
;---------------------------------------------------------------------
DRAW PROC
    mov ax,word ptr buffer[88] ;at position 58h (88d) you have max pixel height
    mov height,ax
    mov di,32000
    mov ax,0a000h ;ax = segment to screen in mode 13h
    mov es,ax ;move seg addr to es
    
    mov bx,0
    @1: ; lea si,buffer
    mov al,text[bx] ; get ascii code
    push bx
    xor ah,ah
    sub ax,32 ;sub it from 32. chars59 begins with space (ascii 32)
    shl ax,2 ;4 bytes for eache char infos
    mov si,ax ;for indexing
    mov cx,word ptr buffer[078h+si] ;the position of the char (see fnt specs)
    mov al,byte ptr buffer[076h+si] ;the first width posi of space in the font file
    
    cmp al,8 ;if only 1 byte width call 1bytewidth
    ja twobytewid
    call onebytewidth ;get char from buffer and show it
    jmp nextchar
TWOBYTEWID:
    call twobytewidth ;get char from buffer and show it
    
NEXTCHAR:
    pop bx
    inc bx
    mov di,32000
    mov ax,14 ;made some spaces between chars
    mul bx ;spaces after a number of char
    add di,ax ;get a new di
    cmp bx,22 ;the number of chars
    jne @1
    ret
DRAW ENDP
    
;---------------------------------------------------------------------

ONEBYTEWIDTH PROC
    mov si,cx ;pointer to the char bitmap at the buffer
    mov dx,height ;"height" rows in a character
    mov bl,col
    mov color,bl
    
    charloop: ;read one of the x rows for a char
    
    lodsb ;one row contains 8 pixels f.e char b 11111100 (first row). load from ds:si to al
;SUB COLOR,3 ;CHANGE COLOR AVERY ROW
    mov bl,al ;use late on to indicate when the pixels is "blank"
    mov cx,8 ;for 8 pixels
    
    rowloop: ;for 8 pixels in a row
    mov al,color ;this value will be store in buffer
    shl bl,1 ;1 pixel stores as 1 byte! store from left to right, f.e 1 is the first value for the char b above. it shifts the read value to left, if the leftmost value is a 1 then the carry flag will rise!! using for the next move
    jc carryset ;use this to indicate whether there is a 0 or a 1
    xor al,al ; no carry means a 0
CARRYSET:
    stosb;just store al in es:di
    
    loop rowloop
;NEW DI POS ON THE SCREEN
    add di,(320-8) ;add a newline minus 16 pixels back
    dec dx ;height
    jnz charloop
    ret
ONEBYTEWIDTH ENDP
;---------------------------------------------------------------------
TWOBYTEWIDTH PROC
    mov si,cx ;pointer to the char bitmap at the buffer
    cmp al,16
    ja use_only_2_column
    sub al,8 ;find the number of pixels needed for the second column
;for proportional fonts U need to "expand" the pixels DYNAMICALLY. Trick: use the predefined 
    mov byte ptr pixel_second_column,al ;the width infos
    jmp @2
USE_ONLY_2_COLUMN:
    mov byte ptr pixel_second_column,8 ;the width infos
@2:
    mov dx,height
    mov bl,col
    mov color,bl
    
CHARLOOP2: ;read one of the x rows for a char
    lodsb ;one row contains 8 pixels f.e char b 11111100 (first row). load from ds:si to al
; SUB COLOR,3 ;CHANGE COLOR AVERY ROW
    mov bl,al ;use late on to indicate when the pixels is "blank"
    mov cx,8 ;for 8 pixels
    rowloop2: ;for 8 pixels in a row
    mov al,color ;this value will be store in buffer
    shl bl,1
    jc carryset2 ;use this to indicate whether there is a 0 or a 1
    xor al,al ; no carry means a 0
CARRYSET2:
    stosb;just store al in es:di
    loop rowloop2
    
;TAKE THE SECOND COLUMN
    add si,height ;take the right side (the second column) of the bitmap font
    sub si,1 ;some justement
    
    lodsb ;one row contains 8 pixels f.e char b 11111100 (first row). load from ds:si to al
;SUB COLOR,3 ;CHANGE COLOR AVERY ROW
    mov bl,al ;use late on to indicate whether the pixels is "blank"
    mov cx,pixel_second_column ;the number of pixels
    rowloop3: ;for 8 pixels in a row
    mov al,color ;this value will be store in buffer
    shl bl,1
    jc carryset3 ;use this to indicate whether there is a 0 or a 1
    xor al,al ; no carry means a 0
CARRYSET3:
    stosb;just store al in es:di
    loop rowloop3
    
;GET BACK TO THE FIRST COLUMN
    sub si,height ;take the left side (1.column)
    
;NEW DI POS ON THE SCREEN
    add di,(320-8);add a newline minus 8 pixels back
    sub di,pixel_second_column ;minus the pixels on the second column
    dec dx ;height
    jnz charloop2
    
    ret
TWOBYTEWIDTH ENDP
;---------------------------------------------------------------------
END START
